Index: /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.cpp	(revision 1158)
@@ -18,3 +18,8 @@
     field->writeUpdateData(data[0]->data);
   }
+
+  bool CFileServerWriterFilter::isDataExpected(const CDate& date) const
+  {
+    return true;
+  }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/file_server_writer_filter.hpp	(revision 1158)
@@ -23,4 +23,5 @@
       CFileServerWriterFilter(CGarbageCollector& gc, CField* field);
 
+      bool virtual isDataExpected(const CDate& date) const;
     protected:
       /*!
Index: /XIOS/dev/dev_olga/src/filter/file_writer_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/file_writer_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/file_writer_filter.cpp	(revision 1158)
@@ -2,4 +2,5 @@
 #include "exception.hpp"
 #include "field.hpp"
+#include "utils.hpp"
 
 namespace xios
@@ -16,5 +17,24 @@
   void CFileWriterFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
+    bool ignoreMissingValue = (!field->detect_missing_value.isEmpty() && 
+                               !field->default_value.isEmpty() && 
+                               field->detect_missing_value == true);
+    if (ignoreMissingValue)
+    {
+      double missingValue = field->default_value;
+      size_t nbData = data[0]->data.numElements();
+      for (size_t idx = 0; idx < nbData; ++idx)
+      {
+        if (NumTraits<double>::isnan(data[0]->data(idx)))
+          data[0]->data(idx) = missingValue;
+      }
+    }    
+
     field->sendUpdateData(data[0]->data);
   }
+
+  bool CFileWriterFilter::isDataExpected(const CDate& date) const
+  {
+    return true;
+  }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/file_writer_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/file_writer_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/file_writer_filter.hpp	(revision 1158)
@@ -23,4 +23,11 @@
       CFileWriterFilter(CGarbageCollector& gc, CField* field);
 
+      /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
     protected:
       /*!
Index: /XIOS/dev/dev_olga/src/filter/filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/filter.cpp	(revision 1158)
@@ -40,3 +40,8 @@
     return (CInputPin::canBeTriggered() || COutputPin::canBeTriggered());
   }
+
+  bool CFilter::isDataExpected(const CDate& date) const
+  {
+    return COutputPin::isDataExpected(date);
+  }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/filter.hpp	(revision 1158)
@@ -48,4 +48,11 @@
       bool virtual canBeTriggered() const;
 
+      /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
     protected:
       IFilterEngine* engine; //!< The filter engine, might be the filter itself
Index: /XIOS/dev/dev_olga/src/filter/input_pin.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/input_pin.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/input_pin.hpp	(revision 1158)
@@ -60,4 +60,11 @@
 
       /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const = 0;
+
+      /*!
        * Removes all pending packets which are older than the specified timestamp.
        *
Index: /XIOS/dev/dev_olga/src/filter/output_pin.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/output_pin.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/output_pin.cpp	(revision 1158)
@@ -73,4 +73,16 @@
   }
 
+  bool COutputPin::isDataExpected(const CDate& date) const
+  {
+    std::vector<std::pair<boost::shared_ptr<CInputPin>, size_t> >::const_iterator it, itEnd;
+    for (it = outputs.begin(), itEnd = outputs.end(); it != itEnd; ++it)
+    {
+      if (it->first->isDataExpected(date))
+        return true;
+    }
+
+    return false;
+  }
+
   void COutputPin::invalidate(Time timestamp)
   {
Index: /XIOS/dev/dev_olga/src/filter/output_pin.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/output_pin.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/output_pin.hpp	(revision 1158)
@@ -46,4 +46,11 @@
 
       /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
+      /*!
        * Removes all pending packets which are older than the specified timestamp.
        *
Index: /XIOS/dev/dev_olga/src/filter/source_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/source_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/source_filter.cpp	(revision 1158)
@@ -3,12 +3,16 @@
 #include "exception.hpp"
 #include "calendar_util.hpp"
+#include <limits> 
 
 namespace xios
 {
   CSourceFilter::CSourceFilter(CGarbageCollector& gc, CGrid* grid,
-                               const CDuration offset /*= NoneDu*/, bool manualTrigger /*= false*/)
+                               const CDuration offset /*= NoneDu*/, bool manualTrigger /*= false*/,
+                               bool hasMissingValue /*= false*/,
+                               double defaultValue /*= 0.0*/)
     : COutputPin(gc, manualTrigger)
     , grid(grid)
     , offset(offset)
+    , hasMissingValue(hasMissingValue), defaultValue(defaultValue)
   {
     if (!grid)
@@ -29,4 +33,16 @@
     packet->data.resize(grid->storeIndex_client.numElements());
     grid->inputField(data, packet->data);
+
+    // Convert missing values to NaN
+    if (hasMissingValue)
+    {
+      double nanValue = std::numeric_limits<double>::quiet_NaN();
+      size_t nbData = packet->data.numElements();
+      for (size_t idx = 0; idx < nbData; ++idx)
+      {
+        if (defaultValue == packet->data(idx))
+          packet->data(idx) = nanValue;
+      }
+    }
 
     onOutputReady(packet);
Index: /XIOS/dev/dev_olga/src/filter/source_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/source_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/source_filter.hpp	(revision 1158)
@@ -23,7 +23,11 @@
        * \param offset the offset applied to the timestamp of all packets
        * \param manualTrigger whether the output should be triggered manually
+       * \param hasMissingValue whether data has missing value
+       * \param defaultValue missing value to detect
        */
       CSourceFilter(CGarbageCollector& gc, CGrid* grid,
-                    const CDuration offset = NoneDu, bool manualTrigger = false);
+                    const CDuration offset = NoneDu, bool manualTrigger = false,
+                    bool hasMissingValue = false,
+                    double defaultValue = 0.0);
 
       /*!
@@ -58,4 +62,6 @@
       CGrid* grid; //!< The grid attached to the data the filter can accept
       const CDuration offset; //!< The offset applied to the timestamp of all packets
+      bool hasMissingValue;
+      double defaultValue;
   }; // class CSourceFilter
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp	(revision 1158)
@@ -11,5 +11,5 @@
 
   std::pair<boost::shared_ptr<CSpatialTransformFilter>, boost::shared_ptr<CSpatialTransformFilter> >
-  CSpatialTransformFilter::buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, double defaultValue)
+  CSpatialTransformFilter::buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, bool hasMissingValue, double missingValue)
   {
     if (!srcGrid || !destGrid)
@@ -26,4 +26,5 @@
       const std::vector<StdString>& auxInputs = gridTransformation->getAuxInputs();
       size_t inputCount = 1 + (auxInputs.empty() ? 0 : auxInputs.size());
+      double defaultValue  = (hasMissingValue) ? std::numeric_limits<double>::quiet_NaN() : 0.0;
       boost::shared_ptr<CSpatialTransformFilter> filter(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
 
@@ -103,5 +104,6 @@
       }
       packet->data.resize(gridTransformation->getGridDestination()->storeIndex_client.numElements());
-      packet->data = defaultValue;
+      if (0 != packet->data.numElements())
+        (packet->data)(0) = defaultValue;
       apply(data[0]->data, packet->data);
     }
@@ -115,6 +117,7 @@
 
     // Get default value for output data
-    double defaultValue = 0.0;
-    if (0 != dataDest.numElements()) defaultValue = dataDest(0);
+    bool ignoreMissingValue = false; 
+    double defaultValue = std::numeric_limits<double>::quiet_NaN();
+    if (0 != dataDest.numElements()) ignoreMissingValue = NumTraits<double>::isnan(dataDest(0));
 
     const std::list<CGridTransformation::SendingIndexGridSourceMap>& listLocalIndexSend = gridTransformation->getLocalIndexToSendFromGridSource();
@@ -191,5 +194,5 @@
         else dataCurrentDest(i) = defaultValue;
 
-      std::vector<bool> localInitFlag(dataCurrentDest.size(), true);
+      std::vector<bool> localInitFlag(dataCurrentDest.numElements(), true);
       currentBuff = 0;
       for (itRecv = itbRecv; itRecv != iteRecv; ++itRecv)
@@ -201,5 +204,5 @@
                          dataCurrentDest,
                          localInitFlag,
-                         defaultValue);
+                         ignoreMissingValue);
 
         currentBuff += countSize;
Index: /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.hpp	(revision 1158)
@@ -32,8 +32,10 @@
        * \param srcGrid the source grid
        * \param destGrid the destination grid
+       * \param hasMissingValue whether field source has missing value
+       * \param defaultValue default value
        * \return the first and the last filters of the filter graph
        */
       static std::pair<boost::shared_ptr<CSpatialTransformFilter>, boost::shared_ptr<CSpatialTransformFilter> >
-      buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, double defaultValue);
+      buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, bool hasMissingValue, double defaultValue);
 
     protected:
Index: /XIOS/dev/dev_olga/src/filter/store_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/store_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/store_filter.cpp	(revision 1158)
@@ -24,5 +24,5 @@
     CTimer timer("CStoreFilter::getPacket");
     CConstDataPacketPtr packet;
-    const double timeout = 10 ; // 10 seconds timeout
+    const double timeout = CXios::recvFieldTimeout;
 
     do
@@ -81,4 +81,9 @@
   }
 
+  bool CStoreFilter::isDataExpected(const CDate& date) const
+  {
+    return true;
+  }
+
   void CStoreFilter::invalidate(Time timestamp)
   {
Index: /XIOS/dev/dev_olga/src/filter/store_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/store_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/store_filter.hpp	(revision 1158)
@@ -50,4 +50,11 @@
 
       /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
+      /*!
        * Removes all pending packets which are older than the specified timestamp.
        *
Index: /XIOS/dev/dev_olga/src/filter/temporal_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/temporal_filter.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/temporal_filter.cpp	(revision 1158)
@@ -5,34 +5,21 @@
 namespace xios
 {
+  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, double missingValue, CArray<double, 1>& tmpData);
+
   CTemporalFilter::CTemporalFilter(CGarbageCollector& gc, const std::string& opId,
                                    const CDate& initDate, const CDuration samplingFreq, const CDuration samplingOffset, const CDuration opFreq,
                                    bool ignoreMissingValue /*= false*/, double missingValue /*= 0.0*/)
     : CFilter(gc, 1, this)
-    , samplingFreq(samplingFreq)
+    , functor(createFunctor(opId, ignoreMissingValue, missingValue, tmpData))
+    , isOnceOperation(functor->timeType() == func::CFunctor::once)
+    , isInstantOperation(functor->timeType() == func::CFunctor::instant)
+    // If we can optimize the sampling when dealing with an instant functor we do it
+    , samplingFreq((isInstantOperation && samplingFreq == TimeStep && samplingOffset == NoneDu) ? opFreq : samplingFreq)
+    , samplingOffset((isInstantOperation && samplingFreq == TimeStep && samplingOffset == NoneDu) ? opFreq - initDate.getRelCalendar().getTimeStep() : samplingOffset)
     , opFreq(opFreq)
-    , nextSamplingDate(initDate + samplingOffset + initDate.getRelCalendar().getTimeStep())
-    , nextOperationDate(initDate + opFreq)
+    , nextSamplingDate(initDate + this->samplingOffset + initDate.getRelCalendar().getTimeStep())
+    , nextOperationDate(initDate + this->samplingOffset + opFreq)
     , isFirstOperation(true)
   {
-#define DECLARE_FUNCTOR(MType, mtype) \
-    if (opId.compare(#mtype) == 0) \
-    { \
-      if (ignoreMissingValue) \
-      { \
-        functor.reset(new func::C##MType(tmpData, missingValue)); \
-      } \
-      else \
-      { \
-        functor.reset(new func::C##MType(tmpData)); \
-      } \
-    }
-
-#include "functor_type.conf"
-
-    if (!functor)
-      ERROR("CTemporalFilter::CTemporalFilter(CGarbageCollector& gc, const std::string& opId, ...)",
-            << "\"" << opId << "\" is not a valid operation.");
-
-    isOnceOperation = (functor->timeType() == func::CFunctor::once);
   }
 
@@ -43,26 +30,42 @@
     if (data[0]->status != CDataPacket::END_OF_STREAM)
     {
-      const bool usePacket = isOnceOperation ? isFirstOperation : (data[0]->date >= nextSamplingDate);
+      bool usePacket, outputResult, copyLess;
+      if (isOnceOperation)
+        usePacket = outputResult = copyLess = isFirstOperation;
+      else
+      {
+        usePacket = (data[0]->date >= nextSamplingDate);
+        outputResult = (data[0]->date + samplingFreq > nextOperationDate);
+        copyLess = (isInstantOperation && usePacket && outputResult);
+      }
+
       if (usePacket)
       {
-        if (!tmpData.numElements())
-          tmpData.resize(data[0]->data.numElements());
+        if (!copyLess)
+        {
+          if (!tmpData.numElements())
+            tmpData.resize(data[0]->data.numElements());
 
-        (*functor)(data[0]->data);
+          (*functor)(data[0]->data);
+        }
 
         nextSamplingDate = nextSamplingDate + samplingFreq;
       }
 
-      const bool outputResult = isOnceOperation ? isFirstOperation : (data[0]->date + samplingFreq > nextOperationDate);
       if (outputResult)
       {
-        functor->final();
+        if (!copyLess)
+        {
+          functor->final();
 
-        packet = CDataPacketPtr(new CDataPacket);
-        packet->date = data[0]->date;
-        packet->timestamp = data[0]->timestamp;
-        packet->status = data[0]->status;
-        packet->data.resize(tmpData.numElements());
-        packet->data = tmpData;
+          packet = CDataPacketPtr(new CDataPacket);
+          packet->date = data[0]->date;
+          packet->timestamp = data[0]->timestamp;
+          packet->status = data[0]->status;
+          packet->data.resize(tmpData.numElements());
+          packet->data = tmpData;
+        }
+        else
+          packet = data[0];
 
         isFirstOperation = false;
@@ -73,3 +76,36 @@
     return packet;
   }
+
+  bool CTemporalFilter::isDataExpected(const CDate& date) const
+  {
+    return isOnceOperation ? isFirstOperation : (date >= nextSamplingDate || date + samplingFreq > nextOperationDate);
+  }
+
+  static func::CFunctor* createFunctor(const std::string& opId, bool ignoreMissingValue, double missingValue, CArray<double, 1>& tmpData)
+  {
+    func::CFunctor* functor = NULL;
+
+    double defaultValue = ignoreMissingValue ? std::numeric_limits<double>::quiet_NaN() : missingValue;
+
+#define DECLARE_FUNCTOR(MType, mtype) \
+    if (opId.compare(#mtype) == 0) \
+    { \
+      if (ignoreMissingValue) \
+      { \
+        functor = new func::C##MType(tmpData, defaultValue); \
+      } \
+      else \
+      { \
+        functor = new func::C##MType(tmpData); \
+      } \
+    }
+
+#include "functor_type.conf"
+
+    if (!functor)
+      ERROR("createFunctor(const std::string& opId, ...)",
+            << "\"" << opId << "\" is not a valid operation.");
+
+    return functor;
+  }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/temporal_filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/temporal_filter.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/filter/temporal_filter.hpp	(revision 1158)
@@ -40,13 +40,22 @@
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
 
+      /*!
+       * Tests whether data is expected for the specified date.
+       *
+       * \param date the date associated to the data
+       */
+      bool virtual isDataExpected(const CDate& date) const;
+
     private:
-      boost::scoped_ptr<func::CFunctor> functor; //!< The functor corresponding to the temporal operation
+      const boost::scoped_ptr<func::CFunctor> functor; //!< The functor corresponding to the temporal operation
       CArray<double, 1> tmpData; //!< The array of data used for temporary storage
       const CDuration samplingFreq; //!< The sampling frequency, i.e. the frequency at which the input data will be used
+      const CDuration samplingOffset; //!< The sampling offset, i.e. the offset after which the input data will be used
       const CDuration opFreq; //!< The operation frequency, i.e. the frequency at which the output data will be computed
       CDate nextSamplingDate; //!< The date of the next sampling
       CDate nextOperationDate; //!< The date of the next operation
       bool isFirstOperation; //!< True before the first operation was been computed
-      bool isOnceOperation; //!< True if the operation should be computed just once
+      const bool isOnceOperation; //!< True if the operation should be computed just once
+      const bool isInstantOperation; //!< True if the operation is instant
   }; // class CTemporalFilter
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/functor/accumulate.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/functor/accumulate.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/functor/accumulate.cpp	(revision 1158)
@@ -1,4 +1,5 @@
 #include "accumulate.hpp"
 #include "array_new.hpp"
+#include "utils.hpp"
 
 namespace xios
@@ -33,7 +34,7 @@
             double* out=_doutput.dataFirst();
             for (i=0; i<n; ++i,++in,++out) 
-              if (*in!=missingValue)
+              if (!NumTraits<double>::isnan(*in))
               {
-                if(*out!=missingValue) *out  += *in;
+                if(!NumTraits<double>::isnan(*out)) *out  += *in;
                 else *out=*in ;
               }
Index: /XIOS/dev/dev_olga/src/functor/average.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/functor/average.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/functor/average.cpp	(revision 1158)
@@ -1,4 +1,5 @@
 #include "average.hpp"
 #include "array_new.hpp"
+#include "utils.hpp"
 
 namespace xios
@@ -42,5 +43,5 @@
             int* nc=nbcalls.dataFirst() ;
             for (i=0; i<n; ++i,++nc,++in) 
-              if (*in!=missingValue) (*nc) ++;
+              if (!NumTraits<double>::isnan(*in)) (*nc) ++;
           }
         }
@@ -54,5 +55,5 @@
             int* nc=nbcalls.dataFirst() ;
             for (i=0; i<n; ++i,++in,++out,++nc) 
-              if (*in!=missingValue) 
+              if (!NumTraits<double>::isnan(*in)) 
               {
                 if (*nc != 0) (*out)  += *in;
Index: /XIOS/dev/dev_olga/src/functor/maximum.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/functor/maximum.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/functor/maximum.cpp	(revision 1158)
@@ -1,6 +1,5 @@
 #include "maximum.hpp"
 #include "array_new.hpp"
-
-
+#include "utils.hpp"
 
 namespace xios
@@ -35,7 +34,7 @@
            { 
              for (; it1 != end1; it1++, it++) 
-               if (*it1 != missingValue)
+               if (!NumTraits<double>::isnan(*it1))
                {
-                 if ( *it != missingValue) *it = std::max(*it1, *it);
+                 if (!NumTraits<double>::isnan(*it)) *it = std::max(*it1, *it);
                  else *it=*it1 ;  
                }
Index: /XIOS/dev/dev_olga/src/functor/minimum.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/functor/minimum.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/functor/minimum.cpp	(revision 1158)
@@ -2,4 +2,5 @@
 #include "array_new.hpp"
 #include <algorithm>
+#include "utils.hpp"
 
 namespace xios
@@ -26,5 +27,5 @@
       {
         const double * it1  = _dinput.dataFirst(),
-                      * end1 = _dinput.dataFirst() + _dinput.numElements();
+                      *end1 = _dinput.dataFirst() + _dinput.numElements();
         double * it   = _doutput.dataFirst();
         
@@ -35,7 +36,7 @@
           { 
             for (; it1 != end1; it1++, it++) 
-              if (*it1!=missingValue)
+              if (!NumTraits<double>::isnan(*it1))
               {
-                if (*it != missingValue) *it = std::min(*it1, *it);
+                if (!NumTraits<double>::isnan(*it)) *it = std::min(*it1, *it);
                 else *it=*it1 ;
               }
Index: /XIOS/dev/dev_olga/src/generate_interface_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/generate_interface_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/generate_interface_impl.hpp	(revision 1158)
@@ -547,4 +547,36 @@
 #undef macro
 
+#define macro(N,EXTENT)\
+  template <>\
+  void CInterface::AttributeCInterface<CArray<StdString,N> >(ostream& oss, const string& className, const string& name)\
+  { \
+    oss << "void cxios_set_" << className << "_" << name << "(" << className << "_Ptr " << className << "_hdl, " << "char* " << name <<", int str_len, int* str_size, int* extent)" << iendl; \
+    oss << "{" << iendl; \
+    oss << "  CTimer::get(\"XIOS\").resume();" << iendl; \
+    oss << "  "<<className<<"_hdl->"<<name<<".resize(shape("<<EXTENT<<"));"<<iendl;\
+    oss << "  Array<StdString,"<<#N<<">::iterator it, itb="<<className<<"_hdl->"<<name<<".begin(), ite="<<className<<"_hdl->"<<name<<".end() ;"<<iendl ;\
+    oss << "  int i, n ;"<< iendl; \
+    oss << "  for(it=itb, i=0, n=0 ; it!=ite ; ++it,n+=str_len,++i) *it=StdString(&"<<name<<"[n],str_size[i]) ;"<<iendl ;\
+    oss << "  CTimer::get(\"XIOS\").suspend();" << iendl; \
+    oss << "}" << std::endl; \
+    oss << iendl; \
+    oss << "void cxios_get_" << className << "_" << name << "(" << className << "_Ptr " << className << "_hdl, " << "char* " << name << ", int str_size, int* extent)" << iendl; \
+    oss << "{" << iendl; \
+    oss << "  CTimer::get(\"XIOS\").resume();" << iendl; \
+    oss << "  Array<StdString,"<<#N<<">::const_iterator it, itb="<<className<<"_hdl->"<<name<<".getInheritedValue().begin(), ite="<<className<<"_hdl->"<<name<<".getInheritedValue().end() ;" << iendl; \
+    oss << "  int n ;"<< iendl; \
+    oss << "  for(it=itb, n=0 ; it!=ite ; ++it, n+=str_size) it->copy(&"<<name<<"[n],it->size()) ; "<< iendl; \
+    oss << "  CTimer::get(\"XIOS\").suspend();" << iendl; \
+    oss << "}" << std::endl; \
+  }
+
+macro(1,"extent[0]")
+macro(2,"extent[0],extent[1]")
+macro(3,"extent[0],extent[1],extent[2]")
+macro(4,"extent[0],extent[1],extent[2],extent[3]")
+macro(5,"extent[0],extent[1],extent[2],extent[3],extent[4]")
+macro(6,"extent[0],extent[1],extent[2],extent[3],extent[4],extent[5]")
+macro(7,"extent[0],extent[1],extent[2],extent[3],extent[4],extent[5],extent[6]")
+#undef macro
 // /////////////////////////////////////////////////
 // //          Fortran 2003 Interface             //
@@ -705,4 +737,35 @@
   #undef macro
 
+#define macro(T)\
+  template <>\
+  void CInterface::AttributeFortran2003Interface<CArray<StdString,T> >(ostream& oss, const string& className, const string& name)\
+  {\
+    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ", str_len, str_size, extent) BIND(C)" << iendl; \
+    oss << "  USE ISO_C_BINDING" << iendl; \
+    oss << "  INTEGER (kind = C_INTPTR_T), VALUE       :: " << className << "_hdl" << iendl; \
+    oss << "  CHARACTER (KIND=C_CHAR), DIMENSION(*)    :: " << name << iendl; \
+    oss << "  INTEGER (kind = C_INT), VALUE            :: str_len" << iendl; \
+    oss << "  INTEGER (kind = C_INT), DIMENSION(*)     :: str_size" << iendl; \
+    oss << "  INTEGER (kind = C_INT), DIMENSION(*)     :: extent" << iendl; \
+    oss << "END SUBROUTINE cxios_set_" << className << "_" << name << std::endl; \
+    oss << iendl; \
+    oss << "SUBROUTINE cxios_get_" << className << "_" << name << "(" << className << "_hdl, " << name << ", str_size, extent) BIND(C)" << iendl; \
+    oss << "  USE ISO_C_BINDING" << iendl; \
+    oss << "  INTEGER (kind = C_INTPTR_T), VALUE       :: " << className << "_hdl" << iendl; \
+    oss << "  CHARACTER (KIND=C_CHAR), DIMENSION(*)    :: " << name << iendl; \
+    oss << "  INTEGER (kind = C_INT), VALUE            :: str_size" << iendl; \
+    oss << "  INTEGER (kind = C_INT), DIMENSION(*)     :: extent" << iendl; \
+    oss << "END SUBROUTINE cxios_get_" << className << "_" << name << std::endl; \
+  }
+  macro(1)
+  macro(2)
+  macro(3)
+  macro(4)
+  macro(5)
+  macro(6)
+  macro(7)
+
+#undef macro
+
 #define macro(T) \
   template <> \
@@ -808,4 +871,31 @@
 
 #undef macro
+
+#define macro(T,EXTENT)\
+  template <> \
+  void CInterface::AttributeFortranInterfaceDeclaration<CArray<StdString,T> >(ostream& oss, const string& className, const string& name)\
+  {\
+    oss << "CHARACTER(len=*) , OPTIONAL, INTENT(IN) :: " << name << "("<<EXTENT<<")"; \
+  }\
+\
+  template <>\ 
+  void CInterface::AttributeFortranInterfaceGetDeclaration<CArray<StdString,T> >(ostream& oss, const string& className, const string& name)\
+  {\
+    oss << "CHARACTER(len=*) , OPTIONAL, INTENT(OUT) :: " << name << "("<<EXTENT<<")"; \
+  }
+  macro(1,":")
+  macro(2,":,:")
+  macro(3,":,:,:")
+  macro(4,":,:,:,:")
+  macro(5,":,:,:,:,:")
+  macro(6,":,:,:,:,:,:")
+  macro(7,":,:,:,:,:,:,:")
+
+#undef macro
+
+
+
+
+  
 
 #define macro(T) \
@@ -947,4 +1037,18 @@
 #undef macro
 
+#define macro(T)\
+  template <>\
+  void CInterface::AttributeFortranInterfaceBody< CArray<StdString,T> >(ostream& oss, const string& className, const string& name)\
+  {\
+     oss << "IF (PRESENT(" << name << "_)) THEN" << iendl; \
+     oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+     oss << "(" << className << "_hdl%daddr, " << name <<"_, LEN("<<name<<"_), LEN_TRIM("<<name<< "_), SHAPE(" << name << "_))" << iendl; \
+     oss << "ENDIF"; \
+  }
+
+  macro(1)
+  macro(2)
+#undef macro
+
 #define macro(T) \
   template <>  \
@@ -1084,4 +1188,24 @@
 
 #undef macro
+
+#define macro(T)\
+  template <> \
+  void CInterface::AttributeFortranInterfaceGetBody< CArray<StdString,T> >(ostream& oss, const string& className, const string& name)\
+  {\
+    oss << "IF (PRESENT(" << name << "_)) THEN" << iendl; \
+    oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+    oss << "(" << className << "_hdl%daddr, " << name << "_, LEN("<<name<<"_), SHAPE(" << name << "_))" << iendl; \
+    oss << "ENDIF"; \
+  }
+  macro(1)
+  macro(2)
+  macro(3)
+  macro(4)
+  macro(5)
+  macro(6)
+  macro(7)
+
+#undef macro
+  
 }
 #endif
Index: /XIOS/dev/dev_olga/src/group_template_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/group_template_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/group_template_impl.hpp	(revision 1158)
@@ -8,4 +8,5 @@
 #include "context.hpp"
 #include "event_client.hpp"
+#include "context_client.hpp"
 #include "message.hpp"
 #include "type.hpp"
@@ -398,22 +399,4 @@
       }
     }
-
-    // if (! context->hasServer )
-    // {
-    //    CContextClient* client=context->client ;
-
-    //    CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;   
-    //    if (client->isServerLeader())
-    //    {
-    //      CMessage msg ;
-    //      msg<<this->getId() ;
-    //      msg<<id ;
-    //      const std::list<int>& ranks = client->getRanksServerLeader();
-    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-    //        event.push(*itRank,1,msg) ;
-    //      client->sendEvent(event) ;
-    //    }
-    //    else client->sendEvent(event) ;
-    // }
       
    }
@@ -464,23 +447,4 @@
       }
     }
-
-    // if (! context->hasServer )
-    // {
-    //    CContextClient* client=context->client ;
-
-    //    CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;   
-    //    if (client->isServerLeader())
-    //    {
-    //      CMessage msg ;
-    //      msg<<this->getId() ;
-    //      msg<<id ;
-    //      const std::list<int>& ranks = client->getRanksServerLeader();
-    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-    //        event.push(*itRank,1,msg) ;
-    //      client->sendEvent(event) ;
-    //    }
-    //    else client->sendEvent(event) ;
-    // }
-      
    }
    
@@ -488,5 +452,4 @@
    void CGroupTemplate<U, V, W>::recvCreateChild(CEventServer& event)
    {
-      
       CBufferIn* buffer=event.subEvents.begin()->buffer;
       string id;
